Scriptname NDY_CD_AutoShoutScript extends activemagiceffect  

ObjectReference property PlayerREF auto
actor player
GlobalVariable Property BasePerk Auto
GlobalVariable Property ChancePerk Auto

Float Property AutoShoutChance = 0.1 Auto Hidden
Int Property ShoutEffect = 0 Auto Hidden

; perk 5
MagicEffect Property DragonForm3 Auto
GlobalVariable Property RestorePerk Auto

; perk 6
MagicEffect Property DragonAddPower Auto
GlobalVariable Property AddPowerPerk Auto
Spell Property DragonAddPowerSpell Auto

; perk 9
MagicEffect Property SummonDragonborn1 Auto
MagicEffect Property SummonDragonborn2 Auto
GlobalVariable Property SummonDragonbornPerk Auto
Spell Property SummonDragonbornSpell1 Auto
Spell Property SummonDragonbornSpell2 Auto

; perk 10
GlobalVariable Property ReduceCooldownPerk Auto

; quest progress check
GlobalVariable property NDY_PerkPoints auto
GlobalVariable property NDY_PerkPointsEarned auto
GlobalVariable property NDY_PerkPointProgress auto
GlobalVariable property NDY_PerkPointsTotal auto


; Dragon Death check
Spell Property NDY_DragonDeathSpell Auto

Keyword Property MagicShout Auto
Formlist Property NDY_NoShoutSpellList Auto
Race Property WerewolfBeastRace Auto

GlobalVariable property NDY_PerkPoints_Quest auto
GlobalVariable property NDY_PerkPoints_MainQuest auto

Quest[] property NDY_PerkPoints_AllQuest auto
int property NDY_QuestMAX auto
Formlist Property NDY_DoneQuestList Auto

GlobalVariable property NDY_PerkPoints_Book auto
GlobalVariable property NDY_PerkPoints_BlackBook auto

Book[] property NDY_PerkPoints_AllBook auto
int property NDY_BookMAX auto
Formlist Property NDY_BookHasReadList Auto

Event OnEffectStart(Actor akTarget, Actor akCaster)
	if akCaster == PlayerREF
;		RegisterforActorAction(4)
		RegisterForSingleUpdate(8)
		RegisterForTrackedStatsEvent()
		player = PlayerRef As Actor
	endif		
EndEvent

Event OnSpellCast(Form akSpell)


; perk 5 effect	
	If player.HasMagicEffect(DragonForm3) && RestorePerk.GetValueInt() == 1
		Float restore = Utility.RandomInt(1,5)
		player.RestoreActorValue("Health", player.GetBaseActorValue("Health")*restore/100)
		player.RestoreActorValue("Stamina", player.GetBaseActorValue("Stamina")*restore/100)
		player.RestoreActorValue("Magicka", player.GetBaseActorValue("Magicka")*restore/100)
	endif
		
; perk 6 effect
	If !player.HasMagicEffect(DragonAddPower) && AddPowerPerk.GetValueInt() == 1
		player.DoCombatSpellApply(DragonAddPowerSpell, player)
	EndIf
		
; perk 9 effect		
	If !player.HasMagicEffect(SummonDragonborn1) && !player.HasMagicEffect(SummonDragonborn2) && SummonDragonbornPerk.GetValueInt() >= 1
		float SummonChance = Utility.RandomFloat()
		if SummonChance <= 0.05 && SummonDragonbornPerk.GetValueInt() == 1
			SummonDragonbornSpell1.cast(PlayerREF)
		elseif SummonChance <= 0.1 && SummonDragonbornPerk.GetValueInt() == 2
			SummonDragonbornSpell2.cast(PlayerREF)
		endif
	EndIf	
	
; perk 10 effect
	If ReduceCooldownPerk.GetValueInt() == 1 && Utility.RandomFloat() <= 0.25
		player.SetVoiceRecoveryTime(0.0)
	EndIf	
		
; perk 2 effect		
	If (akSpell As Spell).HasKeyword(MagicShout) && player.GetRace() != WerewolfBeastRace
	
		If NDY_NoShoutSpellList.Find(akSpell) == -1   &&  BasePerk.GetValueInt() >= 1
			If ChancePerk.GetValueInt() == 0
				AutoShoutChance=0.1
			elseif ChancePerk.GetValueInt() == 1
				AutoShoutChance=0.2
			else
				AutoShoutChance=0.3
			endif
			While Utility.RandomFloat() <= AutoShoutChance
				Utility.Wait(0.4)
;				If AdvancePerk.GetValueInt() == 0
;					ShoutEffect=0
;				elseif AdvancePerk.GetValueInt() == 2
;					ShoutEffect=2
;				else
;					ShoutEffect=Utility.RandomInt(0,2)
;				endif
				(akSpell As Spell).cast(PlayerREF)
;				Debug.Notification("SHOUT HAS BEEN AUTO-CAST!")
			EndWhile
		EndIf			
		
	endif
	
EndEvent


;Event OnActorAction(int actionType, Actor akActor, Form source, int slot)  
;	if akActor == PlayerRef
;		Shout shoutUsed = source as Shout
 ;     	If shoutUsed   
	;		If ShoutList.Find(shoutUsed As Form) != -1   &&  BasePerk.GetValueInt() >= 1
	;			If ChancePerk.GetValueInt() == 0
	;				AutoShoutChance=0.1
	;			elseif ChancePerk.GetValueInt() == 2
	;				AutoShoutChance=0.3
	;			else
	;				AutoShoutChance=0.2
	;			endif
	;			While Utility.RandomFloat() <= AutoShoutChance
	;				Utility.Wait(0.4)
	;				If AdvancePerk.GetValueInt() == 0
	;					ShoutEffect=0
	;				elseif AdvancePerk.GetValueInt() == 2
	;					ShoutEffect=2
	;				else
	;					ShoutEffect=Utility.RandomInt(0,2)
	;				endif
	;				shoutUsed.GetNthSpell(ShoutEffect).cast(PlayerREF)
;					Debug.Notification("SHOUT HAS BEEN AUTO-CAST!")
	;			EndWhile
	;		EndIf
; perk 5 effect

	;		If akActor.HasMagicEffect(DragonForm3) && RestorePerk.GetValueInt() == 1
	;			Float restore = Utility.RandomInt(1,5)
	;			akActor.RestoreActorValue("Health", akActor.GetBaseActorValue("Health")*restore/100)
	;			akActor.RestoreActorValue("Stamina", akActor.GetBaseActorValue("Stamina")*restore/100)
	;			akActor.RestoreActorValue("Magicka", akActor.GetBaseActorValue("Magicka")*restore/100)
	;		endif
; perk 6 effect
	;		If !akActor.HasMagicEffect(DragonAddPower) && AddPowerPerk.GetValueInt() == 1
	;			akActor.DoCombatSpellApply(DragonAddPowerSpell, akActor)
	;		EndIf

    ;	EndIf
;    Endif
;EndEvent

Event OnTrackedStatsEvent(string asStatFilter, int aiStatValue)
    if (asStatFilter == "Words Of Power Learned")
		AdvanceDragonSkill(0.05,2)
	elseif (asStatFilter == "Shouts Mastered")
		AdvanceDragonSkill(0.05,3)	
    endif
EndEvent

Event OnUpdate()
	Int iIndexBook = NDY_BookMAX
	While iIndexBook > 0
		iIndexBook -= 1
		Book ReadBook = NDY_PerkPoints_AllBook[iIndexBook]
		if ReadBook
			if ReadBook.IsRead() && NDY_BookHasReadList.Find(ReadBook) == -1 
				if iIndexBook <= 7
					AdvanceDragonSkill(0.8,4)
					NDY_PerkPoints_BlackBook.SetValue(NDY_PerkPoints_BlackBook.GetValue() + 1)
				else
					AdvanceDragonSkill(0.05,5)	
					NDY_PerkPoints_Book.SetValue(NDY_PerkPoints_Book.GetValue() + 1)
				endif
				NDY_BookHasReadList.AddForm(ReadBook)
			endif
		endif
	EndWhile

	Int iIndexQuest = NDY_QuestMAX
	While iIndexQuest > 0
		iIndexQuest -= 1
		Quest CheckQuest = NDY_PerkPoints_AllQuest[iIndexQuest]
		if CheckQuest
			if CheckQuest.IsCompleted() && NDY_DoneQuestList.Find(CheckQuest) == -1
				If iIndexQuest == 0 || iIndexQuest == 1
					AdvanceDragonSkill(1.0,1)
					NDY_PerkPoints_MainQuest.SetValue(NDY_PerkPoints_MainQuest.GetValue() + 1)
				else
					AdvanceDragonSkill(0.4,0)
					NDY_PerkPoints_Quest.SetValue(NDY_PerkPoints_Quest.GetValue() + 1)
				endif
				NDY_DoneQuestList.AddForm(CheckQuest)
			endif
		endif
	EndWhile
	
	NDY_DragonDeathSpell.cast(PlayerREF)
	
	
	RegisterForSingleUpdate(8)
	
EndEvent

Event OnEffectFinish(Actor akTarget, Actor akCaster)  
;	UnregisterforActorAction(4)
	UnregisterForUpdate()
	UnregisterForTrackedStatsEvent()
EndEvent

function AdvanceDragonSkill(float ProgressValue,Int index)
    if NDY_PerkPointsEarned.GetValueInt() < NDY_PerkPointsTotal.GetValueInt()
        ;Figure out the number of books needed for the next point.
        debug.trace("Advancing DragonPower skill.")
        ; What is the current progress toward the next point?
        NDY_PerkPointProgress.SetValue(NDY_PerkPointProgress.GetValue() + ProgressValue)
        debug.trace("DragonPower perk progress value: " + NDY_PerkPointProgress.GetValue())
		if index == 0
			debug.Notification(";жھ˸⡣")
		elseif index == 1
			debug.Notification(";жԼΪ⣡")
		elseif index == 2
			debug.Notification("֮һЩ֪ʶ")
		elseif index == 3
			debug.Notification("һ֮ڱڲϢ")
		elseif index == 4
			debug.Notification("Īǻл˼ḻľ֪ʶ")
		elseif index == 5
			debug.Notification("鼮ѧϰйصʷ")
		endif
        ; If we have >= 100% progress, give the player a point.
        if NDY_PerkPointProgress.GetValue() >= 1.0
            debug.trace("Granting a DragonPower perk point.")
			debug.Notification("˽ľ֪ʶѾ㹻ḻ1⼼ܵ㣡")
;            NDY_PerkPointsEarned.Show()
            NDY_PerkPointsEarned.SetValueInt(NDY_PerkPointsEarned.GetValueInt() + 1)
            NDY_PerkPoints.SetValueInt(NDY_PerkPoints.GetValueInt() + 1)

            ; If we've maxed out the skill, leave the progress at 100% so the player knows
            ; that they can't get any more advancement in this skill.
            if NDY_PerkPointsEarned.GetValueInt() >= NDY_PerkPointsTotal.GetValueInt()
                NDY_PerkPointProgress.SetValue(1.0)
            else
                NDY_PerkPointProgress.SetValue(NDY_PerkPointProgress.GetValue() - 1.0)
            endif
        endif
    endif
endFunction






