Scriptname NDY_ConfigScript extends activemagiceffect  

ObjectReference property PlayerREF auto

Message Property NDY_Message_MainMenu Auto

Message Property NDY_Message_DragonAttributeMenu Auto
Message Property NDY_Message_IntervalMenu Auto

GlobalVariable Property NDY_Message_DragonAttributeToggle Auto
CD_MagicApplyQuest Property NDY_DragonDetect Auto

Message Property NDY_Message_DragonHealthMenu Auto
GlobalVariable Property NDY_DragonHealthMult Auto
Message Property NDY_Message_DragonAttackMenu Auto
GlobalVariable Property NDY_DragonAttackMult Auto

Message Property NDY_Message_DragonPowerMenu Auto
Message Property NDY_Message_DragonPowerStatsMenu Auto

Message Property NDY_Message_DragonPowerRefundAsk Auto
Message Property NDY_Message_DragonPowerRefundComplete Auto

Globalvariable property NDY_PERK_PerkPoints auto
Globalvariable property NDY_PERK_PerkPointsEarned auto
Globalvariable property NDY_PERK_PerkPointProgress auto
Globalvariable property NDY_PERK_PerkPointsTotal auto

Globalvariable Property NDY_PerkRank_1 auto
Globalvariable Property NDY_PerkRank_2 auto
Globalvariable Property NDY_PerkRank_3 auto
Globalvariable Property NDY_PerkRank_4 auto
Globalvariable Property NDY_PerkRank_5 auto
Globalvariable Property NDY_PerkRank_6 auto
Globalvariable Property NDY_PerkRank_7 auto
Globalvariable Property NDY_PerkRank_8 auto
Globalvariable Property NDY_PerkRank_9 auto
Globalvariable Property NDY_PerkRank_10 auto

GlobalVariable property NDY_PerkPoints_Quest auto
GlobalVariable property NDY_PerkPoints_MainQuest auto
GlobalVariable property NDY_PerkPoints_Book auto
GlobalVariable property NDY_PerkPoints_BlackBook auto
GlobalVariable property NDY_PerkPoints_Dragon auto
GlobalVariable property NDY_PerkPoints_UniqueDragon auto


Event OnEffectStart(Actor akTarget, Actor akCaster)
	if akCaster == PlayerREF
		if !akCaster.IsInCombat()
			MainMenu()
		else
			debug.notification("սУ޷ʹò˵")
		endif
	endif		
EndEvent

Function MainMenu()
	int MainMenuSelect = NDY_Message_MainMenu.Show()
	
	if MainMenuSelect == 0
		DragonAttributeMenu()
;		debug.notification("DragonAttributeMenu Open")
		Return
	elseif MainMenuSelect == 1
		DragonPerkMenu()	
;		debug.notification("DragonPerkMenu Open")
		Return
	elseif MainMenuSelect == 2
;		debug.notification("Close")
		Return
	endif

EndFunction

Function DragonAttributeMenu()
	int MainMenuSelect = NDY_Message_DragonAttributeMenu.Show(NDY_DragonHealthMult.GetValue(), NDY_DragonAttackMult.GetValue() + 1, NDY_DragonDetect.fPollInterval)
	
	if MainMenuSelect == 0
		NDY_Message_DragonAttributeToggle.SetValue(1)
		NDY_DragonDetect.bFrozen = false
		DragonAttributeMenu()
		Return
	elseif MainMenuSelect == 1		
		NDY_Message_DragonAttributeToggle.SetValue(0)
		NDY_DragonDetect.bFrozen = true
		DragonAttributeMenu()
		Return
	elseif MainMenuSelect == 2
		DragonHealthMenu()
		Return
	elseif MainMenuSelect == 3
		DragonAttackMenu()
		Return
	elseif MainMenuSelect == 4
		IntervalMenu()
		Return		
	elseif MainMenuSelect == 5
		MainMenu()
		Return
	endif

EndFunction



Function DragonHealthMenu()
	float mult = NDY_DragonHealthMult.GetValue()
	int MainMenuSelect = NDY_Message_DragonHealthMenu.Show(mult)
	
	if MainMenuSelect == 0
		NDY_DragonHealthMult.SetValue(0.5)
		DragonAttributeMenu()
		Return
	elseif MainMenuSelect == 1
		NDY_DragonHealthMult.SetValue(1.0)
		DragonAttributeMenu()
		Return
	elseif MainMenuSelect == 2
		NDY_DragonHealthMult.SetValue(1.5)
		DragonAttributeMenu()
		Return
	elseif MainMenuSelect == 3
		NDY_DragonHealthMult.SetValue(2.0)
		DragonAttributeMenu()
		Return
	elseif MainMenuSelect == 4
		NDY_DragonHealthMult.SetValue(2.5)
		DragonAttributeMenu()
		Return
	elseif MainMenuSelect == 5
		NDY_DragonHealthMult.SetValue(3.0)
		DragonAttributeMenu()
		Return
	elseif MainMenuSelect == 6
		DragonAttributeMenu()
		Return
	endif

EndFunction

Function DragonAttackMenu()
	float mult = NDY_DragonAttackMult.GetValue()
	int MainMenuSelect = NDY_Message_DragonAttackMenu.Show(mult + 1)
	
	if MainMenuSelect == 0
		NDY_DragonAttackMult.SetValue(-0.5)
		DragonAttributeMenu()
		Return
	elseif MainMenuSelect == 1
		NDY_DragonAttackMult.SetValue(0.0)
		DragonAttributeMenu()
		Return
	elseif MainMenuSelect == 2
		NDY_DragonAttackMult.SetValue(0.5)
		DragonAttributeMenu()
		Return
	elseif MainMenuSelect == 3
		NDY_DragonAttackMult.SetValue(1.0)
		DragonAttributeMenu()
		Return
	elseif MainMenuSelect == 4
		NDY_DragonAttackMult.SetValue(1.5)
		DragonAttributeMenu()
		Return
	elseif MainMenuSelect == 5
		NDY_DragonAttackMult.SetValue(2.0)
		DragonAttributeMenu()
		Return
	elseif MainMenuSelect == 6
		DragonAttributeMenu()
		Return
	endif

EndFunction


Function IntervalMenu()
	float interval = NDY_DragonDetect.fPollInterval
	int MainMenuSelect = NDY_Message_IntervalMenu.Show(interval)
	
	if MainMenuSelect == 0
		NDY_DragonDetect.fPollInterval = 2.0
		DragonAttributeMenu()
		Return
	elseif MainMenuSelect == 1
		NDY_DragonDetect.fPollInterval = 3.0
		DragonAttributeMenu()
		Return
	elseif MainMenuSelect == 2
		NDY_DragonDetect.fPollInterval = 5.0
		DragonAttributeMenu()
		Return
	elseif MainMenuSelect == 3
		NDY_DragonDetect.fPollInterval = 7.0
		DragonAttributeMenu()
		Return
	elseif MainMenuSelect == 4
		NDY_DragonDetect.fPollInterval = 9.0
		DragonAttributeMenu()
		Return
	elseif MainMenuSelect == 5
		NDY_DragonDetect.fPollInterval = 10.0
		DragonAttributeMenu()
		Return
	elseif MainMenuSelect == 6
		DragonAttributeMenu()
		Return
	endif

EndFunction


Function DragonPerkMenu()	
	int MainMenuSelect = NDY_Message_DragonPowerMenu.Show(NDY_PERK_PerkPointsTotal.GetValue(), NDY_PERK_PerkPointsEarned.GetValue(), NDY_PERK_PerkPoints.GetValue(), 100*NDY_PERK_PerkPointProgress.GetValue())

	if MainMenuSelect == 0
		int perk_temp1 = (NDY_PerkPoints_Quest.GetValue() * 40) As Int
		int perk_temp2 = (NDY_PerkPoints_MainQuest.GetValue() * 100) As Int
		int perk_temp3 = (NDY_PerkPoints_Book.GetValue() * 5) As Int
		int perk_temp4 = (NDY_PerkPoints_BlackBook.GetValue() * 80) As Int
		int perk_temp5 = (NDY_PerkPoints_Dragon.GetValue() * 1) As Int
		int perk_temp6 = (NDY_PerkPoints_UniqueDragon.GetValue() * 5) As Int
		int perk_temp7 = (Game.QueryStat("Words Of Power Learned") * 5) As Int
		int perk_temp8 = (Game.QueryStat("Shouts Mastered") * 5) As Int
		NDY_Message_DragonPowerStatsMenu.Show(perk_temp1, perk_temp2, perk_temp3, perk_temp4, perk_temp5, perk_temp6, perk_temp7, perk_temp8)
		DragonPerkMenu()	
		Return
	elseif MainMenuSelect == 1	
		int confirm = NDY_Message_DragonPowerRefundAsk.Show()
;		bool b = ShowMessage("ȷҪ˻Ѿʹõ꼼ܵ㣬Ա·")
		if confirm == 0
			RefundSkillPoints()
			NDY_Message_DragonPowerRefundComplete.Show()
		endif	
		DragonPerkMenu()	
		Return
	elseif MainMenuSelect == 2
		MainMenu()
		Return
	endif	
	
EndFunction



function RefundSkillPoints()
    ClearDragonPowerPerks()
    NDY_PERK_PerkPoints.SetValueInt(NDY_PERK_PerkPointsEarned.GetValueInt())
    NDY_PERK_PerkPointProgress.SetValue(0.0)
endFunction

function ClearDragonPowerPerks()
    ; All current perk rank globals go here.
    NDY_PerkRank_1.SetValueInt(0)
    NDY_PerkRank_2.SetValueInt(0)
    NDY_PerkRank_3.SetValueInt(0)
    NDY_PerkRank_4.SetValueInt(0)
    NDY_PerkRank_5.SetValueInt(0)
    NDY_PerkRank_6.SetValueInt(0)
    NDY_PerkRank_7.SetValueInt(0)
    NDY_PerkRank_8.SetValueInt(0)
    NDY_PerkRank_9.SetValueInt(0)
    NDY_PerkRank_10.SetValueInt(0)
endFunction